# -*- coding: utf-8 -*-

#3a) Un aspetto significativo di una stringa di DNA è il suo contenuto di basi
# G e C (indicato come "GC content" come valore percentuale).
# Scrivere una funzione prefSufGC(s,minlen) che, data una stringa di DNA s, 
# restituisca un prefisso e un suffisso di s, ciascuno di lunghezza minima ma 
# almeno di lunghezza minlen, che abbiano esattamente lo stesso numero di G/C.
# Il risultato deve essere rappresentato come lista di due stringhe. 
#
# Es: s="CCATTACGTGAA"
#     prefSufGC(s,2)  --> ['CC', 'GTGAA']
#     prefSufGC(s,6)  --> ['CCATTAC', 'CGTGAA']


def prefSufGC(s,minlen):
    
    def countGC(t):
        """
        Counts the number of G/C in s
        """
        return t.count('C') + t.count('G')
    
    def enlarge(t,diff):
        """
        Returns the length of the prefix of t, longer than minlen, 
        whose minimal extension wrt minlen contains diff G/G 
        """
        l = minlen
        while diff>0:
            if t[l] in "CG":
                diff-=1
            l+=1
        return l
    
    ps, ss = s[:minlen], s[-minlen:]
    prefGC, suffGC = countGC(ps), countGC(ss)

    content, diff = max(prefGC,suffGC), abs(prefGC - suffGC)

    if prefGC == content: #in this case, we enlarge the suffix
        ss = s[-enlarge(s[::-1],diff) : ]    
    else:  #in this case, we enlarge the prefix
        ps = s[ : enlarge(s,diff)]

    return [ps,ss]

