# -*- coding: utf-8 -*-

#4a) Si scriva una funzione shrinkPerGC(s,minlen) che, operando sulla sequenza
# s di DNA estragga una sua sottosequenza secondo questo criterio:
# si applichi a s la funzione sviluppata al punto 3a) e, se il prefisso e il 
# suffisso ottenuti si sovrappongono, si restituisca s, altrimenti si 
# restituisca il risultato dell'applicazione ricorsiva della stessa funzione 
# a s privata del suffisso e del prefisso calcolati.
#
# Es: s="CCACGAAATGCATCACAGT"
#     shrinkPerGC(s, 2)  --> AATG
#     shrinkPerGC(s, 9)  --> G
#     shrinkPerGC(s,10)  --> CCACGAAATGCATCACAGT


from soluzione3 import prefSufGC

#although its definition is provided in recursive fashion,
#the function can be easily implemented as iterative
    
def shrinkPerGC(s,minlen):
    lpref, lsuff = 0, 0    
    while(len(s)-lsuff > lpref):
        s= s[lpref:len(s)-lsuff]
        pref, suff = prefSufGC(s,minlen)
        lpref, lsuff = len(pref), len(suff)

    return s


#possible recursive solution
def shrinkPerGCrecursive(s,minlen):

    pref, suff = prefSufGC(s,minlen)
    lpref, lsuff = len(pref), len(suff)
    if len(s)-lsuff <= lpref:
        return s
    return shrinkPerGCrecursive(s[lpref:-lsuff],minlen)

