# -*- coding: utf-8 -*-

#1b) Il file INS.fasta si riferisce al trascritto del gene dell'insulina umana,
# e contiene il CDS (sequenza codificante) e la stessa sequenza comprensiva 
# delle regioni introniche.
# Utilizzando il dizionario creato in 1a), determinare il numero di volte che 
# ciascun amminoacido compare codificato nel CDS dell'insulina e scrivere 
# sul file uso1.txt il simbolo a tre lettere dell'amminoacido più frequente
# (nel caso siano più di uno, si riportino tutti in ordine alfabetico su 
# righe succcessive).


from Bio import SeqIO
from soluzione1 import dna2aa, one2three

in_file='INS.fasta'
out_file='uso1.txt'

with open(in_file, 'r') as f:
    record = SeqIO.parse(f, 'fasta').next()
    myseq = str(record.seq)
    
l=len(myseq)

aacount={aaa:0 for aaa in one2three.itervalues()}

i=0
while i<l:
    codon = myseq[i:i+3]
    aacount[dna2aa[codon]]+=1
    i+=3

maxn = max(aacount.itervalues())
maxaa = [aaa for aaa,c in aacount.iteritems() if c==maxn]
     
maxaa.sort()

with open(out_file,'w') as fout:
    for aaa in maxaa:
        fout.write(aaa+'\n')  

